#define INTERRUPT interrupt         // so we can use upper or lower case
#define ENABLE_INTERRUPTS  asm cli; // 'cli' is an assembly language directive 
                                    //  meaning 'enable interrupts'
#define DISABLE_INTERRUPTS asm sei; // 'sei' is an assembly language directive 
                                    //  meaning 'disable interrupts'
#define NEAR near                   // You can obtain more compact code by using 
                                    // near types of addressing modes that use relatively
                                    // small offsets embedded within each instruction,
                                    // i.e. if we agree to have the compiler generate 
                                    // code constrained to only access locations "nearby"
                                    // to some default location or location 0. More 
                                    // compact code also implies less instruction 
                                    // fetching per execution hence performance is better. 
#define VECT_ATTR @0xFF80           // vector interrupt space from absolute address 
                                    // $FF80 to $FFFF (65456 to 65535 decimal)
                                    
#define NUM_WAITS 5         // Number of independent wait counters.
                            // Value is used to declare delay_count[] array size, 
                            // as well as the waiting[] array, and is 
                            // updated in wait decrementing for loop (in 0.010 second timer)
                            
                            
                            