
signed char getLeverDigital(unsigned char num_inputs, unsigned int debounce)
	{
	char GearHex, gear, ix;
	unsigned int upperswitch, lowerswitch;  // switch thresholds for switch manifold debounce
	signed char last_gear; // recent gear lever value

	// variable passed TO function is char, and num_inputs=3 of three inputs active, num_inputs=4 if 4 inputs active
	
	// Initialize gear to current gear (or Drive if it is out of range)
	if ((outpc.manual_gear >= -1) && (outpc.manual_gear <= inpram.num_gears)) gear = outpc.manual_gear; else gear = inpram.num_gears;
	
	last_gear = outpc.manual_gear; // capture most recent gear lever value
		
	// If NAG mode, return Drive
	if (in2ram.ignoreLever == 1) 
		{
		inpram.leverErr = 0;  // clear errors
		in2ram.lever_timer = 0; // clear timer
		return inpram.num_gears; // return 'Drive'
		}
		
	// Initialize gear lever input de-bounce values
	upperswitch = ((debounce * 9)/10);
	lowerswitch = ((debounce)/10);

	for (ix=0; ix<=2; ix++)  // for inputs 1 through 3
		{	 
		if (outpc.Inadc[ix] > inpram.digital_threshold) 
			{    
			if (Inputacc[ix] < 65535) Inputacc[ix]++;
			}  // End if (In1adc[ix] > digital_threshold)
			else 
			{
			if (Inputacc[ix] > 0) Inputacc[ix]--;
			}  // End else (Inadc[]>digital_threshold)
		} // end for (ix=0....
		
	// If PE1 is enabled and high, add to Input4acc  
	if ((FOUR_WD & FOUR_WDpin) && (Inpt4_active))
		{
		if (Inputacc[3] < 65535) Inputacc[3]++; 
		}
		else 
		{
		if (Inputacc[3] > 0) Inputacc[3]--;
		}

	// Check if each input is <10% or >90%, flag and reset to mid-way point if it is
	GearHex = 0x01;
	for (ix=0; ix<=3; ix++)  // for inputs 1 through 3
		{
		if (Inputacc[ix] > upperswitch)	
			{
			Inputstate[ix] = 1;
			// outpc.switches |= GearHex;
			Inputacc[ix] = inpram.debounce/2; 
			}
	   if (Inputacc[ix] < lowerswitch)
			{
			Inputstate[ix] = 0;
			// outpc.switches &= ~(GearHex);
			Inputacc[ix] = inpram.debounce/2; 
			}
		GearHex = GearHex*0x02; // increment 0x01, 0x02, 0x04, 0x08
		}  // end for (ix=0; ix<=3; ix++)

	// Determine the shift lever position.
	// The code will match whatever is put into Input1, Input2, and Input3
	// to find the manual gear lever position.
	// The bit offsets are:
	// P is 0x01
	// N is 0x02
	// R is 0x04
	// 1 is 0x08
	// 2 is 0x10
	// 3 is 0x20
	// 4 is 0x40
	// 5 is 0x80
	// 6 is 0x100
	// 7 is 0x200
	// 8 is 0x400

	GearHex = 0x01; // Initialize hex value for checking gear patterns
	for (ix=0; ix < (inpram.num_gears + 4); ix++)
		{
		if (   ((inpram.Inputptrn[0] & GearHex) == (Inputstate[0] * GearHex)) 
			&& ((inpram.Inputptrn[1] & GearHex) == (Inputstate[1] * GearHex))
			&& ((inpram.Inputptrn[2] & GearHex) == (Inputstate[2] * GearHex))
			&& ((num_inputs < 4) || ((num_inputs == 4) && ((inpram.Inputptrn[3] & GearHex) == (Inputstate[3] * GearHex))))
			)
			{
			// if (i = 0) { gear = 0; PNRset_outputs(0x01); parkNeutral = 1; }  // Park
			// if (i = 1) { gear = 0; PNRset_outputs(0x02); parkNeutral = 2; }  // Neutral
			// if (i = 2) { gear =-1; PNRset_outputs(0x04); parkNeutral = 0; }  // Reverse
			// if (i = 3) { gear = 1; PNRset_outputs(0x00); parkNeutral = 0; }  // First
			// if (i = 4) { gear = 2; PNRset_outputs(0x00); parkNeutral = 0; }  // Second
			// if (i = 5) { gear = 3; PNRset_outputs(0x00); parkNeutral = 0; }  // Third
			// if (i = 6) { gear = 4; PNRset_outputs(0x00); parkNeutral = 0; }  // Fourth
			// if (i = 7) { gear = 5; PNRset_outputs(0x00); parkNeutral = 0; }  // Fifth
			// if (i = 8) { gear = 6; PNRset_outputs(0x00); parkNeutral = 0; }  // Sixth
			// if (i = 9) { gear = 7; PNRset_outputs(0x00); parkNeutral = 0; }  // Seventh
			// if (i =10) { gear = 8; PNRset_outputs(0x00); parkNeutral = 0; }  // Eighth

			if (ix == 2)  // Reverse
				{
				gear = -1;
				PNRset_outputs(0x04);
				parkNeutral = 0;
				}
				else if (ix < 2)  // Park or Neutral
				{
				gear = 0;
				PNRset_outputs(ix+0x01);  // i+1 = 0x02 if i=1, 0x01 if i=0
				parkNeutral = ix+1;    // 1 if Park, 2 if Neutral, 0 otherwise  
				}
				else // if (ix > 2) i.e. forward gear 
				{
				gear = ix-2;
				parkNeutral = 0;
				} // end if (ix == 2)
	
			gear_error = 0; // clear flag because we have a valid gear
			
			if (gear < 2) 
				{
				outpc.lock_TCC = tcc_unlock(); // unlock TCC
				// outpc.hyst_flag = 0;
				STCC_flag = 0;
				}
				else if (gear > inpram.num_gears) gear = inpram.num_gears;
			
			// if have changed gear and are checking for errors   	
			if ((gear != last_gear) && (inpram.leverErr == 1)) gear = checkLever(gear, last_gear);
			
			// make sure gear is in range 
			if (gear > inpram.num_gears) gear = inpram.num_gears;
			if ((gear != -99) && (gear < -1)) gear = inpram.num_gears;
			
			// we found a valid gear, so return it to be assigned to outpc.current_gear
			return (gear); // if turned into function
			} // end if (((inpram.Inputptrn[0] & GearHex) ...
			GearHex = GearHex * 0x02; // 0x01, 0x02, 0x04, 0x08, ... only if we have not found a gear and returned
		} // end for (i=1,i<=NUM_GEARS,i*2)
		
		// no gear found
		// if checking lever errors
		if (inpram.leverErr == 1) gear = inpram.num_gears; else gear = outpc.manual_gear;
		if ((gear != last_gear) && (inpram.leverErr == 1)) gear = checkLever(gear, last_gear); // check if we have changed gears or need to report error

		return(gear);
	} // end (signed char) getLeverDigital
	

signed char getLeverADC(unsigned int ADCcount)
	{
	signed char gear, ix;
	int threshADC; // manual gear lever ADC gear range variables
	signed char ADC_indx, swap_flag, tmp, order[11]; // gear sorted into ascending ADC order
	signed char last_gear; // recent gear lever value
	
	// If NAG mode, return Drive
	// if (inpram.NAGmode == 1) return inpram.num_gears;
	if (in2ram.ignoreLever == 1) 
		{
		inpram.leverErr = 0;  // clear errors
		in2ram.lever_timer = 0; // clear timer
		return inpram.num_gears; // return 'Drive'
		}
			
	// If voltage is outside valid range, return current lever position
	if ((ADCcount > inpram.maxADCLeverVolts) || (ADCcount < inpram.minADCLeverVolts)) return(outpc.manual_gear);


    gear_error = 0;

	// Capture current gear so we can tell if gear position has changed
	last_gear = outpc.manual_gear; // capture most recent gear lever value
	
	gear = -99;	  // set impossible value, will be returned if no gear is found
	
	// remove - leave in last state 
	// parkNeutral = 0;  // 0 for forward gears, 1 for Park, 2 for Neutral
	
	// Populate the order index before sorting

	order[0] =  0; // 0 = P   ==  0
	order[1] =  1; // 1 = N   == -2
	order[2] =  2; // 2 = R   == -1
	order[3] =  3; // 3 = 1st ==  1
	order[4] =  4; // 4 = 2nd ==  2
	order[5] =  5; // 5 = 3rd ==  3
	order[6] =  6; // 6 = 4th ==  4
	if (inpram.num_gears > 4)  order[7] =  7; else  order[7] = -9;  //  7 = 5th
	if (inpram.num_gears > 5)  order[8] =  8; else  order[8] = -9;  //  8 = 6th
	if (inpram.num_gears > 6)  order[9] =  9; else  order[9] = -9;  //  9 = 7th
	if (inpram.num_gears > 7) order[10] = 10; else order[10] = -9;  // 10 = 8th
	
	// sort the user ADC counts into order
	// order[11] is array of gears, so if we have:
	// order[0] = 4, order[1] = 2, order[2] = R then gear 4 has the lowest voltage, 2nd is next lowest, etc.

    swap_flag = 1; // initialize
    while (swap_flag)
		{
		swap_flag = 0; // set to zero so we will stop if no swaps are made
		for (ix=0; ix < (inpram.num_gears + 3); ix++) // from 0 to 6 for 4 speed
			{
			if (inpram.mleverVolts[order[ix]] > inpram.mleverVolts[order[ix + 1]])
				{
				tmp = order[ix];
				order[ix] = order[ix+1];
				order[ix+1] = tmp;
				swap_flag = 1; 
				} // end if (inpram.mleverVolts[ix] > ...
			}  // end for (ix=1; ix < ...
		}  // end while (swap_flag)		
	
 	// find the next lower ADC
	// Ex. if 4th has the lowest voltage, then order[0] = 4
	//		and ADC_indx == mleverVolts[4] = lowest volts
	// mleverVolts is 0 - 10, PNR12345678
	ADC_indx = 0;
	
	for (ix=0; ix < (inpram.num_gears + 3); ix++)	   // from 0 to 6 for 4 speed
		{
		if (ADCcount >= inpram.mleverVolts[order[ix]]) ADC_indx = ix;
		}
		
	// find out if voltage is closer to higher or lower ADC
	// deltaVlow = ADCcount - inpram.mleverVolts[ADC_index];
	// deltaVhigh = inpram.mleverVolts[ADC_index + 1] - ADCCount;
	// must be higher than ((inpram.mleverVolts[ADC_index + 1] - inpram.mleverVolts[ADC_index])/2) + inpram.deadband else use lower
	// Ex.

	if (ADC_indx < inpram.num_gears + 2) 
		{
		threshADC = ((inpram.mleverVolts[order[ADC_indx]] + inpram.mleverVolts[order[ADC_indx + 1]] + 1)/2);
		}
		else
		{
		threshADC = 1023;
		}
	
	if (ADCcount <= inpram.mleverVolts[order[0]])
		{
		gear = order[0] - 2; // don't check ADC dead band if below lowest value
		}	
		else if (ADCcount >= inpram.mleverVolts[order[inpram.num_gears + 2]])
		{
		gear = order[inpram.num_gears + 2] - 2; // don't check ADC dead band if above highest value
		}
		else if (ADCcount >= (threshADC + inpram.mleverdead)) 
		{
		gear = order[ADC_indx + 1] - 2; // next higher voltage's gear
		}
		else if (ADCcount <= (threshADC - inpram.mleverdead)) 
		{
		gear = order[ADC_indx] - 2;	 // next lower voltage's gear
		}
		else
		{
		gear = -99;
		gear_error = 1;
		}
	
	if ((gear < 1) && (gear > -2)) 
		{  	// order[0] =  0; // 0 - 2 = P  ==  -2, should be -2
			// order[1] =  1; // 1 - 2 = N  ==  -1, should be  0
			// order[2] =  2; // 2 - 2 = R  ==   0, should be -1
		gear = (gear * -1) - 1;
		}
			
	// if in Park, set flag	
	if (gear == 0) 
		{
		parkNeutral = 1;
		}
		else if (gear == -2) // Neutral
		{
		gear = 0;
		parkNeutral = 2;
		}

	if ((gear >= -2) && (gear <= inpram.num_gears)) gear_error = 0; // clear flag because we have a valid gear
	
	if (gear < 2) 
		{
		outpc.lock_TCC = tcc_unlock(); // unlock TCC
		// outpc.hyst_flag = 0;
		STCC_flag = 0;
		}
		else if (gear > inpram.num_gears) 
		{
		gear = inpram.num_gears; // Make sure it is in range	
		}
	if ((gear != last_gear) && (inpram.leverErr == 1)) gear = checkLever(gear, last_gear); // check if we have changed gears or need to report error
		
	return(gear);
} // end signed char getLeverADC()
	

signed char checkLever(signed char gear, signed char last_gear)
	{
	signed char difference; // difference between gear positions
/*
	// if we have shifted from P to D
	if ((last_gear < 1) && (last_gear != -99) && (gear >= 1) && (gear <= inpram.num_gears)) 
		{
		if (outpc.speedo < 5)  // only if not moving
			{
			outpc.target_gear = 1; // initialize target gear
			}
			// else do nothing, don't change target gear		
		} // end if ((last_gear < 1) && (last_gear != -99) && ...
*/		
	// check forward gears only
	if ((gear >= 1) && (gear <= inpram.num_gears) && (last_gear >= 1) && (last_gear <= inpram.num_gears))
		{
		if (last_gear > gear)
			{  // down shift
			difference = last_gear - gear;
			}
			else
			{  // upshift or no shift
			difference = gear - last_gear;
			}
		}
		else  // PNR or error
		{
		difference = 1; // nominal value to allow lever position change
		}
	
	if ((gear == -99) || (difference > in2ram.maxDeltaLever)) // if gear is invalid or too far away 
		{
		outpc.switches |= 0x80;           	// set 8th bit for datalog
		if (outpc.lever_count > 1)
			{
			gear = outpc.manual_gear; 	// report the last found gear if no gear found 
										// and timer is running
			
			}
			else if (outpc.lever_count == 0)  // no gear found and timer not set
			{
			outpc.lever_count = in2ram.lever_timer;  // start timer if we haven't already
			gear = inpram.num_gears;    // report Drive
			}
			// if lever_count == 1 we will report 'gear', == -99
	    }
	    else   // valid gear found
	    {
	    outpc.lever_count = 0; // reset timer, don't alter new 'gear' lever value so let code shift, etc.
	    outpc.switches &= ~0x80;    // clear 8th bit for datalog
	    }

	// check if we have changed gear	
	if ((gear != last_gear) && (gear != -99))
		{
		outpc.TCC_count = 0; // reset the hysteresis values
		outpc.hyst_timer = 0;
		shiftSpeedHyst_flag = 0;
		}

	return(gear);
	} // end checkLever()
