// --- Global Variables ----
// The variables declared below are global, and available to all functions.
signed int tmpLOAD;   // internal LOAD variables 
unsigned char restart;
unsigned int VSS_error;
unsigned int  os_rpm;           // output shaft rpm
unsigned char error_flags;      // check states for error reporting - same definition as outpc.error
int last_LOAD,last_mph,last_kpa,last_tps,high_mph;
char Inputstate[4];             // switch states for switch manifold gear determination
unsigned int Inputacc[4];       // switch state debounce variables

int UP_avg, DWN_avg, MODE_avg;  // Shift button 'pressed' average, shift only 
                                // after reaches user threshold
unsigned char ICintmask[2];
volatile unsigned short *pTIC[2],*pTOC[2]; // The asterisk (*) in the variable declaration 
                                           // indicates this is a "pointer".
                                           // That means that these variables hold the address
                                           // in memory of another variable.
unsigned int mms,millisec,burn_flag,can_mmsclk,can_varoff;
unsigned int TC_ovflow,TC_ov_ix;
unsigned long lmms,
  ltch_lmms,
  rcv_timeout,adc_lmms;
unsigned char flocker;
unsigned char next_adc,first_adc,
	txmode,tble_idx,burn_idx,      // txmode is 1st received character in serial comms, burn_idx is the table to burn
	reinit_flag;
unsigned int speedo_total,speedo_toggle,speedo_counter;
unsigned long ic1_per_avg;
unsigned long ic2_per_avg;
unsigned long ic1_period[22];    // VSS period array - take the average
unsigned long ic2_period[22];    // ISS period array - take the average
unsigned char ic1_count, ic1_recount;
unsigned char ic2_count;
unsigned int LOAD_long;
long ic1_per_acc;                // VSS averaging subtotal
long ic2_per_acc;                // ISS averaging subtotal
long vss_divide;                 // Calculated from number of teeth on VSS sensor, etc.
unsigned int minTics, vssTics;   // minimum number of VSS tics
char kill_ser,vfy_flg;
char Output1state;               // Output1 state indicator
char Output2state;               // Output2 state indicator
char Output3state;               // Output3 state indicator
char Output4state;               // Output4 state indicator
char Output5state;               // Output5 state indicator
char Output6state;               // Output6 state indicator
char Output7state;               // Output7 state indicator
char Output8state;               // Output8 state indicator
char Output9state;               // Output9 state indicator
unsigned long loop_count;        // main loop counter
unsigned long vss_teeth;         // VSS tooth counter
char VSS_rcvd;                   // flag for VSS tooth
int pulsewidth1;                 // from CAN for fuel efficiency calcs
char dither_flag;                // PWM dither and refresh flags
int dither_counter;              // dither counter for zero to dither_int+dither_dur
int refresh_counter;             // refresh counter for output1 and output2 from zero 
                                 // to refresh_int+refresh_dur                              
unsigned int out1_pwm_count;     // output1/5/6 and output2 counter (in 0.128 clock tics)
unsigned int out2_pwm_count;     // output2 counter (in 0.128 clock tics)
unsigned char sp1_pwm_count;     // spare port 1 pwm counter
unsigned int sp2_pwm_count;      // spare port 2 pwm counter
unsigned char sp1_pwm_hi;        // activate sp1 pwm high ticks 
unsigned int sp2_pwm_hi;         // activate sp2 pwm high ticks
unsigned int sp2_pwm_total;      // sp2 total period
signed int sp1_indicial;         // value to check against spare port 1 index bins
signed int sp2_indicial;         // value to check against spare port 2 index bins 
unsigned long short_period_vss;  // calculated mask times for VSS timer
unsigned long long_period_vss;   // calculated mask times for VSS timer
unsigned long short_period_iss;  // calculated mask times for VSS timer
unsigned long long_period_iss;   // calculated mask times for VSS timer
unsigned short tcsav1;           // Last VSS time
unsigned short tcsav2;           // Last ISS/non-CAN tach time
unsigned char LUF_counter;       // Lock-Up Feel counter (0.10 sec tics)
unsigned char prev_gearlever;    // position of gear lever before checking state again
unsigned char IdleFlag;          // 1=have set idle adjustment, 0=have reset idle adjustment to 0
unsigned char Inpt4_active;      // status of bit 3 of stdin_cfg iff bit 0 is 1 (i.e. using 4th lever input)
unsigned char FWD_LogOnly;       // 1 if log only, 0 if use for table/2WD+4WD
unsigned char dc_32;             // 3/2 duty cycle calculated from inpram.out2dc
unsigned char jake_brake;        // diesel engine brake status
char jx,kx,mx;
unsigned char uctmp;
unsigned int shift_release;      // shift release duration (to re-enable buttons)
unsigned char burn_msec_flag;    // flag to not burn next step of flash until milliseconds have ticked over
unsigned char LUF_start;         // initial LUF value from Calc_Initial_LUF()
unsigned char STCC_flag;         // full time TCC lock up flag
unsigned char shiftSpeedHyst_flag; // shift speed captured flag
unsigned char gear_error;        // flag for a valid gear found (0 if found, 99 if not)
unsigned char shiftStatcounter;  // shift status counter
unsigned char tmpVSF;            // speedo factor
unsigned long speedoFactor;      // intermediate calculation for speedometer (to reduce Timer ISR load)
unsigned char rev_shift_flag;    // revs forced shift
unsigned char shifting_flag;     // flag for shifting         
unsigned char WOT_flag;          // 0 if not WOT, 1+ otherwise  (increment to 10, then reset) 
unsigned char sp0,sp3;           // spare port 0 (speedo output) and 3 (line pressure) status
unsigned char sp[2];             // spare port 1,2 status, 1=on, 0=off
unsigned char parkNeutral;       // 1 = Park, 2 = Neutral, 0 otherwise
unsigned int Slip_msec;          // milliseconds since slip began                       
unsigned char waiting[NUM_WAITS];// flag for wait state (waitAwhile(index, cycles); ) 
signed int Pintcpt, Pslope;   	 // y-intercept and slope for custom pressure sensor
unsigned int ODOmsec, ODOlastSpeed;    // last time OD was calculated
unsigned int DelayTimer1;         // delay timer (decremented in timer ISR 1 millisecond section 
unsigned int DelayTimer2;         // delay timer (decremented in timer ISR 1 millisecond section 
unsigned char Sflag;			  // slip flag
unsigned char PC_table_value;     // raw PC table value
unsigned int msecVSS;             // VSS timer (1/8 msec)
signed char last_target_gear;     // last valid target gear									
unsigned char lastCANcheck;       // msec since last CANbus check
unsigned int last0001, last0010, lastADC, last0100, last1000; // time of last call (msec; or seconds for last1000)
unsigned char adc_channel;       // last ADC channel sampled
unsigned char adc_flag;          // adc conversions in progress
unsigned int last_decel_mph;     // last speed reading (every 1/10th of a second)
unsigned long period1;
unsigned int VSS_ovflow;         // number of VSS timer overflows (0xFFFF tics)
unsigned long TC0_up, TC0_dwn;	 // TC0 count at last rising/falling edge
unsigned long TC0_last;			 // TC0 count at last valid edge
unsigned long effective_axle_ratio; // intermediate ratio
unsigned char TCC_follow_count1; // 0.010 second counter for TCC follow mode for sp1
unsigned char TCC_follow_count2; // 0.010 second counter for TCC follow mode for sp2
unsigned char TCC_follow_flag1;  // TCC follow flag for sp1 (1=TCC already applied, 0=TCC not yet applied)
unsigned char TCC_follow_flag2;  // TCC follow flag for sp2 (1=TCC already applied, 0=TCC not yet applied)
unsigned char tmp_U08;           // to hold register values