// Revision version of MShift code

const char RevNum[20] =  {    // revision no:
  // Only change for major rev and/or interface change. (The last character is added by GPIO.)
#ifdef COMMS_382X
  //"MShift 6.XXX       "
    "MShift 6.201       "
  // 123456789.123456789.
#else
  //"MShift 5.XXX       "
    "MShift 5.201       "
  // 123456789.123456789.
#endif
  // Put this in the title bar. 
},
 Signature[32] = {            // program title.
  // Change this every time you tweak a feature.  (The last character is added by GPIO.)
#ifdef COMMS_382X
  //"**  V6.XXX MegaShift by B&G  **"
    "**  V6.201 MegaShift by B&G  **"
  // 123456789.123456789.123456789.12
#else
  //"**  V5.XXX MegaShift by B&G  **"
    "**  V5.201 MegaShift by B&G  **"
  // 123456789.123456789.123456789.12
#endif
 };
 
/*
Code Change Log
---- ------ ---

V1.000 to V1.100
---------------- 
All basic functions added:
- Fully user configurable automatic or manual mode, with user tables for shift speeds and line pressures based on speed and load,
- User configurable output and input patterns (to adapt to many 4-speed automatic transmissions - defaults are for GM 4L60E trans),
- Speed in 0.1 mph (or kph) increments
- Odometer in 0.001 mile (kilometer) increments (in addition to a VSS tooth counter)
- Full datalogging of speed, gear, odometer, line pressure, etc., as well as main loops counter, etc.
- Provisions for 'paddle' shifters on steering wheel
- Four LED indicators for current gear
- Adaptive load sensing interprets your driving style and adjusts shifts to reflect 'hard' or easy' driving
- TunerStudio display of shift button status, braking, gear, TCC status, speed, load, odometer, trans temperature, etc.
- Built in code for a 0.5-4.5V line pressure sensor
- Configurable (pulse/mile) 12V square wave hardware speedometer output for electronic speedometers (user sets the pulse per mile)
- Two spare outputs that can be set by a user-specified combination of vehicle speed, engine rpm, load, or current gear (with user-set 
hysteresis to prevent rapidly cycling near the switch points). These can alternatively be used as 'clutch outputs' (i.e., active only during a shift),
- GM (digital inputs) or Ford style (varying voltage) shift lever determination. If the Ford style is used, 
the addition 2 inputs can be used for datalog voltage signals (temperatures, TPS, MAP, etc.)
- 2/4WD speedometer scaling. 

V2.000 to V2.103
----------------
- up to 8 forward speeds allowed (+P/N/R), 
- fourth shift solenoid output added on spare2 (PA0/VB2/Amp12). Has 'bit-banged' PWM and refresh cycles (like output1 and output2), 
- fourth digital shift lever input added on PE1/GPI1/Amp5, 
- CAN pass-through added, 
- added user defined spark retard for upshifts and for downshifts, 
- added user defined spark retard by gear (above a user specified load threshold) for 2nd and higher gears, 
- added user setting for IAC adjustment while stopped in neutral (Idle-Up) to prevent stalling
- added user setting for ignition advance adjustment while stopped in neutral (Idle-Up) to prevent stalling
- user specified output patterns for the LED outputs (especially useful for interfacing with a seven segment LED driver)
- 'jake brake' mode added using line pressure pin as input
- auto_gear_lookup() call and CAN variable assignment moved to timer interrupt from main loop
- outpc reduced from 88 bytes to 56 bytes
- serCANcomm updates from A. Grippo (Sept.25/10)
- added outmsg to match 2.904 (pw1, rpm, map, tps, vBatt)
- fixed odometer roll-over issue
- fixed metric odometer scaling bug (/10)
- made minimum speed in manual a user parameter to allow 2nd for starting in slippery conditions
- added shift button polarity parameter
- added shift button blocking/delay/re-enable after shift
- fixed trans_temp_limit scaling error in INI
- changed flash burn timing from main loop counter based timing to millisec based with flag 
- jump to flash burn if gear lever position cannot be determined, rather than loop
- expanded outpc to 58 bytes and blocking Factor to 64 bytes
- added flash burn to waitAwhile()
- changed default ISS pulse/revolution from 40 to 31 (4L80E)
- added TCC PWM for non-LUF applications (free spare port 2)
- added option to use Input 2 and Input 3 as shift solenoids if using voltage based input for shift lever
- added maxSpeed as user setting for VSS filtering
- added option to check for 'hot reset' by looking at engine rpm and VSS interrupts
- removed reset speedo to 0 on reset unless the current gear is 1
- improved logic for manual/auto switch at minimum manual speed
- removed shift to first on switch to manual mode at low speed
- user input resetTime (time to ignore filtering on reset) 
- added TCC hysteresis time as user variable
- ISS calculation rearrangement to help prevent overflows
- is_rpm added back to outpc
- fix for PC PWM not being correctly reported in neutral
- changed under/over-rev to down/up-shift, but not change mode
- PWM% reported in outpc (instead of 0 or 1)
- added full time TCC mode (based on rpm and gear)
- fixed indexing issue in auto_gear_lookup()
- moved last_mph and last_kpa (for shift hysteresis) to 0.010 second section of timer from auto_gear_lookup()
- fixed TCC PWM% reporting during taper period
- added VSS smoothing factor
- limit VSS_mask to 200
- added WOT_flag to outpc/datalog
- fixed table indexing issue where last column wasn't being used
- minTics adjusted to allow 20% tolerance for short but valid pulses
- fixed hysteresis so it is a flag (rather than always evaluating against last values)
- disabled speedo averaging below 1.5*minSpeed
- change kpa_hyst scaling to 1x from 10x
- change short-term average divider from 1/4 to 1/8
- out of range manual_gear error changed from 'outpc.manual_gear = 99' to new flag 'gear_error = 99'
- fix for gear_error initialization (back-ported from 4.003)
- added rev_shift_flag to properly shift on over/under rev in auto mode (also in 2.107)

V2.104 to V2.123
---------------------
- major architectural changes to functionalize shifts (shiftTo(), afterShiftRevs(), etc.), etc.
- TCC individual upshift lock/unlock behavior is user configurable
- maximum line pressure setting for each individual up or down shift user settable
- fix for the line pressure reporting during the pressure adjustment delay
- fix for the 100 kPa railing of MAP over CAN (also back-ported to 2.102)
- number of code sections for port set-up and related purposes were moved from main.c 
  to #include files to make it easier to find specific functional code sections and improve compile times
- removed sprfactor_table (saving 2048 bytes of code space)
- Output3 setting and CAN retard moved to setOut3PWM() function
- moved all direct GPIO I/O port references to #included file "ports_pins.h" 
  to allow easy migration to other platforms 
- added check to clear gear error flag in ADC manual lever mode (back ported to 2.103)
- redefined NO_GEARS as NUM_GEARS, NO_TEMPS as NUM_TEMPS, NO_MPH as NUM_MPH, etc. for clarity ("NUMber" of rather than NO == negatives
- fixed metric units tire diameter (also in 2.104)
- fixed speedo output on PT4 (also in 2.105)
- speedo output PWMPER4 default changed from 120 to 30 (also 2.105)
- PWMPER4 added to inpram (as pwmper4) and INI inpram/menus (but commented out in menu)
- button behavior changed so first press changes mode to manual, second and subsequent change gears (also in 2.105)
- buttons ignored while in PNR (switch states set to zero in resetShiftRequests())
- revert to auto_mode at all times in PNR
- only allow 1,2 start-up auto modes for inpram.shift_mode (not 0 = manual)  
- speedo output toggling moved to incorporate VSS filtering 
- added SPI basic data register read/write and set up infrastructure as functions (in SPI_code.h)
- added WOMM (@ 0x0256) to hcs12def.h for SPI
- added SPI solenoid selection parameter (in2ram.SPIsoln)
- renamed 'solA(), ..., solF()' to 'Output1(), ..., Output6()'
- fixed TPS limiting when using MAP over CAN (also in 2.109)
- added user input for WOT duration, default set to 0 (disabled), was hard-coded 10 seconds (also in 2.109)
- fixed voltage based lever logic (also in 2.111)
- fixed rev limiting (both for shift blocking and running rpm)
- fixed spare port PWM% reporting issue
- allowed IC1/IC2 input masking to be disabled
- input masking always disabled if ic1_per_avg < 0x00FFFFFF

2.124 to 2.131
--------------
- added second gear shift table (and speed/load bins) activated by 2/4WD input
- changed shift table size to 16x9 from 12x12
- independent speed/load bins added for pressure control table
- merged outpc variables upbutton, dwnbutton, upshift_request and 
  downshift_request into outpc.shift action, with:
  -- bit 0: Down button
  -- bit 1: Up button
  -- bit 2: Downshift request
  -- bit 3: Upshift_request
 - removed outpc.sp1 and outpc.sp2 variables (use outpc.sp1PWM and outpc.sp2PWM instead)
 - combined outpc.brake/burnstatus/FWD into outpc.miscStatus:
  -- bit 0: Brake
  -- bit 1: burnstatus
  -- bit 2: FWD
 - removed all references (variable names, etc.) to switchA, switchB, etc.; they are now Input1, Input2, ...
 - prevented dither pulse while shifting (interferes with max shift pressures)
 - fixed PC PWM condition in shiftTo (from PC > maxUPpressure to PC > (100-maxUPpressure))
 - outpc.manual_gear reports -99 if manual gear lever position not found
 - fixed bug in ISS (period values not assigned to array)
 - implemented ISS masking disable (set mask to 0)
 - speedo correction table added
 - fix ISS/non-CAN tach code
 - added configurable pull-ups on PAD00, PAD01, PAD03 for microTCU
 - changed FWD_factor default value to 1000 (x1000) (for second shift table usage)
 - added check for rev forced shift only if not already set
 - auto_gear_lookup only if rev_shift_flag not set
 - target gear set to current_gear  1 if rev_shift flag set
 
 4.100 to 4.104
 --------------
 - for speedo output:
  -- added 16x9 PWM table with user selectable indexes
  -- added PWM, TCC, shift solenoid (Output8) and clutch modes
 - added check conditions for Outputs 5,6,7,8 to getGear()
 - added upshift timing retard to shitftTo()
 - added CAN retard checking to main loop
 - added 2 new outpc variables: sp09inx and sp016inx for spare port 0 indexes. 
   If PWM not used on sp0, these report ms2_tps and raw speedo (and sp0PWM 
   reports shiftStat.
 - added check for FWD_cfg for In4_cfg, In4_cfg now renamed to Inpt4_active 
   Inpt4_active == 1 if bits 0 AND 3 are high, 0 otherwise
   (but not in INI since this value is a mix of two bits settings in stdin_cfg)
 - if gear lever is less the 1 AND equal to 99, current_gear is set to zero
 - removed section that set P and N outputs patterns to the same pattern
 - separate checks for lever in P or N (for future use)
 - fixed issue in which check for P in which Input4state was not multiplied by 0x02
 - added PNRset_outputs() function to set shift solenoids
 - fixed Reverse LED issue
 - added different LED patterns for P and N
 - added flashing ability to PN LEDs (to match R)
 - added flashing in manual mode to active LEDs
 - added 2 point pressure sensor calibration
 - added user options for forcing auto mode
 - fixed spare port 1/2 PWM issue (wasn't fully low when off)
 - added dead band to lever voltage (user settable)
 
4.110 to 4.123
--------------
- added user option (in2ram.LEDflash) to flash LEDs in forward gears 
  if shift mode is manual
- added nested interrupts (when #define COMMS_382X is uncommented near line 198) 
  with user option (in2ram.nestedINTS) otherwise use old comms
  Old comms used for release. Must not activate COMM_382X in INI
- added user option (in2ram.SlipOptn) to report either converter or internal slip
  (only available if using ISS).
- fixed ISS calculation (to use current gear instead of speed as index)
- exposed 2-point pressure sensor values, added parameter to inpram.line_units.
- rpm limited to > 99 if calculated from output shaft (VSS)
- fixed inpram incrementing error in INI (affected dead band voltage)
- added CAN adjustment reset to shiftTo() function
- corrected slip calculation
- moved processor initialization from main() in main.c to InitProcessor.h
- moved MShift variable initialization from main() in main.c to InitMShift.h
- moved manual lever determination code from main() in main.c to getLever.h
- change Input1-4 related variables to Input1-4[] arrays (in globals.h) to 
  simplify lever determination code with for(;;) loops
- exposed forceAUTOoptn.
- fixed bug in mlever code.
- removed stdoutput_cfg from code and INI (was no longer used))
- rewrote user spare port logic, rearranged related parameters in inpram
- fixed bug in output4 shift solenoid code
- fixed metric 4WD odometer calculation bug (4WD correction wasn't being done at all).
- fixed bug in slip calc (ic2_usage not anded with 0x01); required since bit7 used for edge selection
- added DEBUG setting to INI with pad10 and INdbug as input variables (#set DEBUG to display)
- added limit to make sure pressure control duty cycle is not less than lowest table value
  regardless of rounding/truncating or voltage/temperature adjustments
- renamed define "PC" to "PC_DUTY", and "PC_ON" to PC_PER"
- fix microTCU pull-ups (disable ADC and use as digital inputs if microTCU and digital not ADC)
- limit getLeverDigital() return value to be <= highest gear
- fixed metric temperature conversion
- change NOT_METRIC setting in INI to IMPERIAL
- fix VSS period bug in INI
- added speed x time odometer() function to replace old VSS pulse based calcs
- changed speedo and PWM calcs to use proper rounding rather than truncating 
- changed speedo correction default values all to 0.0
- fixed sp2 index bug, was using index from sp1
- removed unused variables
- removed old outpc code segment
- added limit on line pressure in neutral to only be set if rpm > 300
- remove 99 rpm lower rpm limit
- added reverse gear pressure options and setting
- fixed parkNeutral setting bug in digital lever code (affected LEDs)
- re-wrote getLeverADC(), fixed gear_error bug
- added option to use mixed MAP/TPS for load table indexes
- added conditions to pc table value only if: 
	(CAN & rpm >= 300) 
	OR (no CAN && (ISS/tach & rpm > 300) 
	OR (no CAN & no ISS/tach) 	 // ignore rpm
- fixed 2-point calibration calcs
- blocked shifts if gear_error isn't 0
- removed the pc lookup rpm limits
- fixed 2-pt calcs issue where inserted test ADC value wasn't removed
- moved all metric conversions to INI, removed inpram.Metric_Units, added INI setting for SI_LENGTHS
- removed ADC reporting on line pressure because of INI metric/imp. conversions, use 2-pt instead to get ADC 

5.000 to 5.014
--------------
- added 6x6 TPSxRPM lookup table for load
- added MAP versus TPS percentage for load
- removed inpram.load_type (not needed with TPS/MAP percentages)
- fix auto_gear_lookup() return value if hysteresis (to target_gear from current_gear)
- add lookup table for shift completion delay
- fixed error in spare port 2 PWM conditions
- added option for line pressure output as spare port 3 with 16x9 PWM table
- renamed ms2_tps to outpc.rawTPS
- added menuDisplay to inpram; not used in code, only used for menus in TS
- added slip based PC PWM calcs
- fixed bug in slip calculation
- removed power2(n) function, use (1 << n) instead
- changed waitAwhile() function to a 1 msec delay timer with while loop 
	-- INI values are now x1 msec (were x8)
- fixed TPS gear table hysteresis (also 4.126)
- fixed out-of-bound array index for pressure limit was shifting from PNR
- fixed TCC issue (STCC improperly applied)
- removed smoothing on outpc.in1adc when used as digital input
- leave gears in last state if manual gear lever indeterminate
- fixed TPS hysteresis scaling factor
- added CANbus VSS capability
- added TCC load hysteresis
- added user setting for speedo output PWM%
- added use of PE0 for table switching
- changed line_pressure in outpc and INI to signed int (to prevent roll-under by allowing negative numbers)
- fixed speedo output switching to eliminate PWM
- added dbug2 to outpc to bring up to 80 bytes
- fixed outpc size error in INI
- make sure speed output signal is generated (speedo_toggle != 0 or speedo_total) 
- fixed jake brake to only activate if line_units == 2
- added aux volts to indices for spare ports
- added gear mode for spare port 2
- implemented minimum speed and LOAD for slip based PC_duty adjustments
- fixed 'uint' cast on non-CAN load to 'sint'
- check baud rate to make sure it has not been corrupted by flash burn, etc.
- added Tach/ISS ratios for all driven gears to allow for different ISS pick-up points (i.e. 4L80E)
- fixed non-CAN load scaling in code

5.015 to 5.017
--------------
- changed LOAD_long to outpc.LOAD in dither calculation
- changed rpm < 300 check on PC control to only check if (CAN enabled) OR if (CAN disabled and ic2 used as tach input) 
- corrected numerous typos in source code files
- removed sprfactor_table
- fixed spark slip count
- removed unused variables
- renamed temporary variables to include type (tmp1_U08, tmp2_S16, etc.)
- cleared all shift buttons (as well as shift requests) on successful shift
- made sure under-rev was not checked in low gear, over-rev not checked in high gear 
  (to prevent attempt to shifts to neutral or invalid gear)
- mlever and target gear fixes from 4.144
- D2mode added
- added LED status to outpc
- fixed jake brake status issue
- fixed many manual gear lever issues
- set default for manual gear lever errors to 'ignore'
- fixed manual lever 4th input issue
- sorted out outpc.miscStatus JakeBrake/baudError bits
- replaced MSVAR_NUM_BYTES with in2ram.msOutpcBytes
- added in2ram burnout_maxgear for highest gear in burnout mode
- renamed D2mode to burnout_mode
- added 2WD/4WD bit to datalog

5.090/6.090 to 5.099
--------------------------
- added 382X comms
- code branches into 5.xxx and 6.xxx. 5.xxx series of code for the 2.9xx code, and started
  a new 'shadow' series 6.xxx to be compatible with the 3.82x+ codes. Both would be 
  functionally the same other than the old/new serial functions (and equivalent codes 
  would retain the same decimal designation).
- split 5.xxx and 6.xxx INIs 
- moved Timer_Clock_ISR() code into Timer0001(), Timer0010(), Timer0100(), and Timer1000()
  to be called in main loop and delay loops
- added more filtering to individual VSS pulses based on current raw speedo value
- added outpc.cruising_flag status value (number of seconds cruising, to be used to limit rate of speedo change (to prevent dropouts)
- added tcsav1 = TC0_save; when ic1_period is too long
- implemented inpram.burnout_maxgear for follow mode
- TestLog.txt format changed to spreadsheet in source files directory
- added option to update short-term load while braking
- inpram.digital_threshold now applies to Input1, Input2, Input3, Brake, and PaddleDOWN
- added decel mode to restrict downshifts on deceleration or VSS drop-outs 
- fixed error in INI for negative inpram.IACAdjngear
- numerous fixes to lever and target gear code
- numerous speedo changes
- outpc now has VSS_per (32 bits) for direct ic1 input period measurement
- default VSS mask is now 80% (was 0%). This improves speedo stability with low voltage VR signal
- fixed 2-pt calculations for line pressure 
- fixed PC table value to use LOAD rather than LOAD_short 
- wrote NEW_VSS interrupt routine to use both edges of VSS signal to eliminate spikes
- added provision for VSS placement on wheel rather than output shaft
- fixed scaling on shift completion delay table
- added intermediate gear ratio (for FWD transmissions)
- added instantaneous ratio to outpc as instant_ratio (from new function getRatio())
- added current estmated_gear (for NAG mode) in new function getCurrentGear()
- added option for RPM based shifting
- changed default TPSmap to 50:50 instead of 100% MAP (plus a couple of minor adjustments to TPS vrs. RPM table)  
- added transmission type modes
- added option to ignore lever inputs
- changed initial values for target gear and manual gear to num_gears from 4
- added CANVSSadj to adjust external CANbus speedo signal
- fixed speedo correction so that smoothing occurs after adjustment only
- made all CANbus offsets user-settable for both outpc and outmsg
- increase canVSS offset max in INI from 255 to 1024
- made NEW VSS a user option
- fixed PE0/PE1 table switching
- fixed 2-point non-CANbus load calculation units and table lookup error
- added ability to always lock in highest gear
- added delay for grabbing post-shift hysteresis values
- changed default TPSmap load parameter to 25% MAP (& 75% TPS) (from 50%/50%)
- added options for changed load adjusting with WOT TPS/rising load, decel mode, and braking
- edited shift tables to reduce number of load zones by making some rows duplicates 

5.100 to 5.111/6.xxx
--------------------
- fixed line pressure shift options for spare port 3 in PWM mode
- cleaned up commented-out code in main.c and 4.000_changes.h
- spell check sources and INI
- fix INI turboBaud error (not setting CAN_COMMANDS soon enough)
- fix for setting target gear == manual gear due to hysteresis
- limit non-zero vss_mask and iss-mask to 55 to 200
- fix VSS error incrementing from "+= input_mask;" to "++;"
- added 'per gear' upper and lower rev limits (rpm_limit[] and lower_rev_limit[])
- put minimum decel mode speed (inpram.min_dcl_spd) as a lower limit on decel mode, 
  with default = 10.0 mph
- put option to ignore shift button states
- clears shift and hyst flags on change of table
- added actual shift table number to datalog
- added checks for valid target_gear and valid current_gear to main loop
- restricted getGear() matches from 1 to num_gears (rather than 8)
- in INI the correct units are displayed for minimum decel mode speed
- INI fix to the speedo output parameter when using metric lengths
- fixed TCC cold unlock issue when temperature should have been ignored, 
  i.e. if bit 1 (0x02) of inpram.stdin_cfg was 0
- fixed sp2 issue when used during 'shift only', only sp1 was switched in shiftTo() function
- changed line pressure PSI scaling to not divide by 10 in code, and not use 0.100 in INI, 
  changed metric (Bar) from 0.0068947 to 0.068947 in INI
- fix Input2 error (ADC was correct, but In2 state was only calculated if hardware != 0)
- added test_mode to allow user substitution of all input values

5.200 to 5.201/6.xxx
--------------------
- ROM_7000 full, so moved various routines to NON_BANKED 
- removed MAT_ROM, MAF_ROM, EGO_ROM, etc. and expanded OVF_ROM  (PPAGE 3D is empty)
- fixed tach value assignment when using ISS input but still using CANbus
- added CANbus load, rpm, and vBatt to available test variables
- added vBatt, testing_inputs (mirrors inp2ram.test_mode), shiftStat, rawSpeedo, 
  and lever_count to outpc. (increases from 96 to 104 Bytes) to INI and datalog
- added battery voltage gauge to INI
- added in3ram + in3flash + in3padding (jump version to 5.200)
- moved SPI input parameters to in3ram.

 */